# strings_func.h File Reference

Functions related to OTTD's strings. More...

`#include "strings_type.h"`

Go to the source code of this file.

## Data Structures
struct | StringIDCompare
| Key comparison function for std::map. More...
## Functions
char * | InlineString (char *buf, StringID string)
char * | GetString (char *buffr, StringID string, const char *last)
char * | GetStringWithArgs (char *buffr, uint string, int64 *argv, const char *last)
| The highest 8 bits of string contain the "case index".
const char * | GetStringPtr (StringID string)
void | InjectDParam (uint amount)
| Shift the string parameters in the global string parameter array by amount positions, making room at the beginning.
static void | SetDParamX (uint64 *s, uint n, uint64 v)
| Set a string parameter v at index n in a given array s.
static void | SetDParam (uint n, uint64 v)
| Set a string parameter v at index n in the global string parameter array.
void | SetDParamStr (uint n, const char *str)
| This function is used to "bind" a C string to a OpenTTD dparam slot.
static uint64 | GetDParamX (const uint64 *s, uint n)
| Get the current string parameter at index n from parameter array s.
static uint64 | GetDParam (uint n)
| Get the current string parameter at index n from the global string parameter array.
static void | CopyInDParam (int offs, const uint64 *src, int num)
| Copy num string parameters from array src into the global string parameter array.
static void | CopyOutDParam (uint64 *dst, int offs, int num)
| Copy num string parameters from the global string parameter array to the dst array.
bool | ReadLanguagePack (int index)
void | InitializeLanguagePacks ()
| Make a list of the available language packs.
const char * | GetCurrentLanguageIsoCode ()
| Get the ISO language code of the currently loaded language.
int CDECL | StringIDSorter (const StringID *a, const StringID *b)
void | CheckForMissingGlyphsInLoadedLanguagePack ()
| Check whether the currently loaded language pack uses characters that the currently loaded font does not support.
## Variables
DynamicLanguages | _dynlang
| Language information of the program.

## Detailed Description

Functions related to OTTD's strings.

Definition in file strings_func.h.

## Function Documentation

void CheckForMissingGlyphsInLoadedLanguagePack | ( |  | ) |

Check whether the currently loaded language pack uses characters that the currently loaded font does not support.

If this is the case an error message will be shown in English. The error message will not be localized because that would mean it might use characters that are not in the font, which is the whole reason this check has been added.

Definition at line 1516 of file strings.cpp.

References FS_NORMAL, INVALID_STRING_ID, LanguagePackHeader::isocode, LoadStringWidthTable(), SetDParamStr(), SetFallbackFont(), ShowErrorMessage(), TD_LTR, DynamicLanguages::text_dir, UninitFreeType(), and LanguagePackHeader::winlangid.

Referenced by GameOptionsWindow::OnDropdownSelect().

static void CopyInDParam | ( | int | offs,
|  | const uint64 * | src,
|  | int | num |
| ) |  |  | `[inline, static]`

Copy num string parameters from array src into the global string parameter array.

Parameters:

  | offs | Index in the global array to copy the first string parameter to.
  | src | Source array of string parameters.
  | num | Number of string parameters to copy.

Definition at line 80 of file strings_func.h.

References _decode_parameters.

Referenced by DrawNewsString(), NewsWindow::DrawWidget(), ErrmsgWindow::DrawWidget(), QueryWindow::SetStringParameters(), ErrmsgWindow::SetStringParameters(), NewsWindow::UpdateWidgetSize(), and ErrmsgWindow::UpdateWidgetSize().

static void CopyOutDParam | ( | uint64 * | dst,
|  | int | offs,
|  | int | num |
| ) |  |  | `[inline, static]`

Copy num string parameters from the global string parameter array to the dst array.

Parameters:

  | dst | Destination array of string parameters.
  | offs | Index in the global array to copy the first string parameter from.
  | num | Number of string parameters to copy.

Definition at line 92 of file strings_func.h.

References _decode_parameters.

Referenced by AddNewsItem().

const char* GetCurrentLanguageIsoCode | ( |  | ) |

Get the ISO language code of the currently loaded language.

Returns:
  the ISO code.

Definition at line 1501 of file strings.cpp.

References LanguagePackHeader::isocode.

Referenced by GameOptionsWindow::DrawWidget(), and GameOptionsWindow::UpdateWidgetSize().

static uint64 GetDParam | ( | uint | n | ) | `[inline, static]`

Get the current string parameter at index n from the global string parameter array.

Parameters:

  | n | Index of the string parameter.

Returns:
  Value of the requested string parameter.

Definition at line 66 of file strings_func.h.

References _decode_parameters, and lengthof.

Referenced by ShowErrorMessage().

static uint64 GetDParamX | ( | const uint64 * | s,
|  | uint | n |
| ) |  |  | `[inline, static]`

Get the current string parameter at index n from parameter array s.

Parameters:

  | s | Array of string parameters.
  | n | Index of the string parameter.

Returns:
  Value of the requested string parameter.

Definition at line 56 of file strings_func.h.

Referenced by ErrmsgWindow::DrawWidget(), and ErrmsgWindow::OnInitialPosition().

char* GetStringWithArgs | ( | char * | buffr,
|  | uint | string,
|  | int64 * | argv,
|  | const char * | last |
| ) |  |  |

The highest 8 bits of string contain the "case index".

These 8 bits will only be set when FormatString wants to print the string in a different case. No one else except FormatString should set those bits, therefore string CANNOT be StringID, but uint32.

Parameters:

  | buffr |
  | string |
  | argv |
  | last |

Returns:
  a formatted string of char

Definition at line 103 of file strings.cpp.

References error(), GB(), GetGRFStringID(), GetInt32(), GetStringWithArgs(), and HasBit().

Referenced by GetStringWithArgs(), and GetTownName().

void InitializeLanguagePacks | ( |  | ) |

Make a list of the available language packs.

put the data in _dynlang struct.

< Matching the language in the configuartion file or the current locale

< Using pt_PT for pt_BR locale when pt_BR is not available

< Fallback when no locale-matching language has been found

Definition at line 1439 of file strings.cpp.

References DynamicLanguages::curr_file, DynamicLanguages::ent, Language::file, FOR_ALL_SEARCHPATHS, GetCurrentLocale(), GetLanguageFileHeader(), GetLanguageList(), LanguagePackHeader::isocode, LANG_DIR, lengthof, MAX_LANG, LanguagePackHeader::name, Language::name, DynamicLanguages::num, and usererror().

void InjectDParam | ( | uint | amount | ) |

Shift the string parameters in the global string parameter array by amount positions, making room at the beginning.

Parameters:

  | amount | Number of positions to shift.

Definition at line 180 of file strings.cpp.

References _decode_parameters, and lengthof.

Referenced by Subsidy::AwardTo().

static void SetDParam | ( | uint | n,
|  | uint64 | v |
| ) |  |  | `[inline, static]`

Set a string parameter v at index n in the global string parameter array.

Parameters:

  | n | Index of the string parameter.
  | v | Value of the string parameter.

Definition at line 40 of file strings_func.h.

References _decode_parameters, and lengthof.

Referenced by AircraftEntersTerminal(), Subsidy::AwardTo(), ChangeIndustryProduction(), NetworkChatWindow::ChatTabCompletionNextItem(), CheckAllowRemoveRoad(), CheckIfAuthorityAllowsNewStation(), CheckOrders(), CheckTrainCollision(), CheckTrainsLengths(), CmdBuildAirport(), CmdBuildBridge(), CmdBuildIndustry(), CmdCompanyCtrl(), CmdDecreaseLoan(), CmdFoundTown(), CmdIncreaseLoan(), Disaster_CoalMine_Init(), DisasterTick_Aircraft(), DisasterTick_Big_Ufo(), DisasterTick_Zeppeliner(), DoCommandPInternal(), DrawAircraftDetails(), StationViewWindow::DrawCargoRatings(), NetworkContentListWindow::DrawDetails(), DrawEngineList(), SelectCompanyManagerFaceWindow::DrawFaceStringLabel(), BaseGraphWindow::DrawGraph(), IndustryViewWindow::DrawInfo(), DrawOrderString(), DrawPrice(), TownAuthorityWindow::DrawRatings(), DrawRoadVehDetails(), NetworkGameWindow::DrawServerLine(), SettingEntry::DrawSetting(), DrawShipDetails(), SmallMapWindow::DrawTowns(), DrawTrainDetails(), DepotWindow::DrawVehicleInDepot(), BaseVehicleListWindow::DrawVehicleListItems(), DrawVehiclePurchaseInfo(), DrawVehicleRefitWindow(), StationViewWindow::DrawWaitingCargo(), VehicleViewWindow::DrawWidget(), VehicleDetailsWindow::DrawWidget(), RefitWindow::DrawWidget(), TownDirectoryWindow::DrawWidget(), TownViewWindow::DrawWidget(), TownAuthorityWindow::DrawWidget(), ScenarioEditorToolbarWindow::DrawWidget(), TimetableWindow::DrawWidget(), SubsidyListWindow::DrawWidget(), StatusBarWindow::DrawWidget(), SelectStationWindow< T >::DrawWidget(), CompanyStationsWindow::DrawWidget(), SmallMapWindow::DrawWidget(), SignListWindow::DrawWidget(), OrdersWindow::DrawWidget(), MessageHistoryWindow::DrawWidget(), NetworkJoinStatusWindow::DrawWidget(), NetworkContentDownloadStatusWindow::DrawWidget(), MusicWindow::DrawWidget(), MusicTrackSelectionWindow::DrawWidget(), SaveLoadWindow::DrawWidget(), TooltipsWindow::DrawWidget(), BuildIndustryWindow::DrawWidget(), VehicleGroupWindow::DrawWidget(), PerformanceRatingDetailWindow::DrawWidget(), CompanyLeagueWindow::DrawWidget(), PaymentRatesGraphWindow::DrawWidget(), GraphLegendWindow::DrawWidget(), GenerateProgressWindow::DrawWidget(), EnginePreviewWindow::DrawWidget(), BuyCompanyWindow::DrawWidget(), CompanyWindow::DrawWidget(), CompanyFinancesWindow::DrawWidget(), CheatWindow::DrawWidget(), BuildBridgeWindow::DrawWidget(), ReplaceVehicleWindow::DrawWidget(), AISettingsWindow::DrawWidget(), AIListWindow::DrawWidget(), DrawYearColumn(), GenerateDefaultSaveName(), IndustryDirectoryWindow::GetIndustryString(), AIVehicle::GetName(), AITown::GetName(), AISign::GetName(), AIIndustry::GetName(), AIGroup::GetName(), AIEventEnginePreview::GetName(), AIEngine::GetName(), AICompany::GetName(), AIBaseStation::GetName(), GetNameOfOwner(), AICompany::GetPresidentName(), GetSaveLoadErrorString(), VehicleGroupWindow::GroupNameSorter(), IndustryDirectoryWindow::IndustryNameSorter(), IndustryProductionCallback(), MaybeNewIndustry(), NetworkHandlePauseChange(), WaypointWindow::OnClick(), VehicleDetailsWindow::OnClick(), TownViewWindow::OnClick(), TimetableWindow::OnClick(), StationViewWindow::OnClick(), CustomCurrencyWindow::OnClick(), GameSettingsWindow::OnClick(), OrdersWindow::OnClick(), NetworkStartServerWindow::OnClick(), IndustryViewWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), DepotWindow::OnClick(), CompanyWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), BuildVehicleWindow::OnClick(), AISettingsWindow::OnClick(), GenerateLandscapeWindow::OnDropdownSelect(), SmallMapWindow::OnInit(), SelectCompanyManagerFaceWindow::OnInit(), HighScoreWindow::OnPaint(), EndGameWindow::OnPaint(), ReplaceVehicleWindow::OnPaint(), AirportPickerWindow::OnPaint(), BuildIndustryWindow::OnPlaceObject(), DepotWindow::OnRightClick(), ReportNewsProductionChangeIndustry(), SaveHighScoreValue(), SetArrivalDepartParams(), SetDParamStr(), WaypointWindow::SetStringParameters(), ExtraViewportWindow::SetStringParameters(), VehicleViewWindow::SetStringParameters(), VehicleDetailsWindow::SetStringParameters(), VehicleListWindow::SetStringParameters(), RefitWindow::SetStringParameters(), TownDirectoryWindow::SetStringParameters(), TownViewWindow::SetStringParameters(), TownAuthorityWindow::SetStringParameters(), TimetableWindow::SetStringParameters(), StationViewWindow::SetStringParameters(), CompanyStationsWindow::SetStringParameters(), SmallMapWindow::SetStringParameters(), SignWindow::SetStringParameters(), SignListWindow::SetStringParameters(), CustomCurrencyWindow::SetStringParameters(), GameDifficultyWindow::SetStringParameters(), GameOptionsWindow::SetStringParameters(), BuildSignalWindow::SetStringParameters(), BuildRailStationWindow::SetStringParameters(), OskWindow::SetStringParameters(), OrdersWindow::SetStringParameters(), NewsWindow::SetStringParameters(), NewGRFWindow::SetStringParameters(), NetworkStartServerWindow::SetStringParameters(), NetworkGameWindow::SetStringParameters(), MusicTrackSelectionWindow::SetStringParameters(), QueryWindow::SetStringParameters(), QueryStringWindow::SetStringParameters(), SelectGameWindow::SetStringParameters(), IndustryDirectoryWindow::SetStringParameters(), IndustryViewWindow::SetStringParameters(), BuildIndustryWindow::SetStringParameters(), VehicleGroupWindow::SetStringParameters(), CreateScenarioWindow::SetStringParameters(), GenerateLandscapeWindow::SetStringParameters(), DepotWindow::SetStringParameters(), SetDateWindow::SetStringParameters(), BuyCompanyWindow::SetStringParameters(), CompanyWindow::SetStringParameters(), SelectCompanyLiveryWindow::SetStringParameters(), CompanyFinancesWindow::SetStringParameters(), BuildVehicleWindow::SetStringParameters(), ReplaceVehicleWindow::SetStringParameters(), AIDebugWindow::SetStringParameters(), AIConfigWindow::SetStringParameters(), SetTimetableParams(), ShowAdditionalText(), ShowNewGRFError(), ShowNewGrfVehicleError(), ShowRejectOrAcceptNews(), SignList::SignNameSorter(), CompanyStationsWindow::StationNameSorter(), TownDirectoryWindow::TownNameSorter(), TrainDetailsCapacityTab(), TrainDetailsCargoTab(), TrainDetailsInfoTab(), Waypoint::UpdateVirtCoord(), Town::UpdateVirtCoord(), Station::UpdateVirtCoord(), Sign::UpdateVirtCoord(), VehicleDetailsWindow::UpdateWidgetSize(), TownDirectoryWindow::UpdateWidgetSize(), TownAuthorityWindow::UpdateWidgetSize(), ScenarioEditorToolbarWindow::UpdateWidgetSize(), TimetableWindow::UpdateWidgetSize(), StatusBarWindow::UpdateWidgetSize(), SelectStationWindow< T >::UpdateWidgetSize(), SignListWindow::UpdateWidgetSize(), CustomCurrencyWindow::UpdateWidgetSize(), GameDifficultyWindow::UpdateWidgetSize(), GameOptionsWindow::UpdateWidgetSize(), BuildRailStationWindow::UpdateWidgetSize(), MessageHistoryWindow::UpdateWidgetSize(), NetworkJoinStatusWindow::UpdateWidgetSize(), NetworkGameWindow::UpdateWidgetSize(), MusicTrackSelectionWindow::UpdateWidgetSize(), TooltipsWindow::UpdateWidgetSize(), SelectGameWindow::UpdateWidgetSize(), BuildIndustryWindow::UpdateWidgetSize(), PerformanceRatingDetailWindow::UpdateWidgetSize(), CompanyLeagueWindow::UpdateWidgetSize(), PaymentRatesGraphWindow::UpdateWidgetSize(), BaseGraphWindow::UpdateWidgetSize(), GenerateProgressWindow::UpdateWidgetSize(), CreateScenarioWindow::UpdateWidgetSize(), GenerateLandscapeWindow::UpdateWidgetSize(), EnginePreviewWindow::UpdateWidgetSize(), DepotWindow::UpdateWidgetSize(), SetDateWindow::UpdateWidgetSize(), BuyCompanyWindow::UpdateWidgetSize(), CompanyWindow::UpdateWidgetSize(), CompanyFinancesWindow::UpdateWidgetSize(), CheatWindow::UpdateWidgetSize(), BuildBridgeWindow::UpdateWidgetSize(), ReplaceVehicleWindow::UpdateWidgetSize(), and VehicleNameSorter().

void SetDParamStr | ( | uint | n,
|  | const char * | str |
| ) |  |  |

This function is used to "bind" a C string to a OpenTTD dparam slot.

Parameters:

  | n | slot of the string
  | str | string to bind

Definition at line 171 of file strings.cpp.

References SetDParam().

Referenced by Subsidy::AwardTo(), CheckForMissingGlyphsInLoadedLanguagePack(), CmdCompanyCtrl(), CmdFoundTown(), DrawCargoListText(), NetworkContentListWindow::DrawDetails(), IndustryViewWindow::DrawInfo(), GameOptionsWindow::DrawWidget(), NewsWindow::DrawWidget(), NetworkContentDownloadStatusWindow::DrawWidget(), NetworkChatWindow::DrawWidget(), MusicWindow::DrawWidget(), MusicTrackSelectionWindow::DrawWidget(), LandInfoWindow::DrawWidget(), BuildIndustryWindow::DrawWidget(), AIConfigWindow::DrawWidget(), AIListWindow::DrawWidget(), IndustryDirectoryWindow::GetIndustryString(), GetSaveLoadErrorString(), IndustryProductionCallback(), MakeScreenshot(), CustomCurrencyWindow::OnClick(), NewGRFWindow::OnClick(), NetworkStartServerWindow::OnClick(), NetworkGameWindow::OnClick(), SaveFileError(), CustomCurrencyWindow::SetStringParameters(), GameOptionsWindow::SetStringParameters(), NewGRFWindow::SetStringParameters(), NetworkLobbyWindow::SetStringParameters(), AboutWindow::SetStringParameters(), AIDebugWindow::SetStringParameters(), ShowNewGRFError(), ShowNewGrfVehicleError(), ShowRefitOptionsList(), StartScenario(), GameOptionsWindow::UpdateWidgetSize(), NewGRFWindow::UpdateWidgetSize(), NetworkChatWindow::UpdateWidgetSize(), MusicWindow::UpdateWidgetSize(), MusicTrackSelectionWindow::UpdateWidgetSize(), LandInfoWindow::UpdateWidgetSize(), BuildIndustryWindow::UpdateWidgetSize(), and WarnCorruptSprite().

static void SetDParamX | ( | uint64 * | s,
|  | uint | n,
|  | uint64 | v |
| ) |  |  | `[inline, static]`

Set a string parameter v at index n in a given array s.

Parameters:

  | s | Array of string parameters.
  | n | Index of the string parameter.
  | v | Value of the string parameter.

Definition at line 30 of file strings_func.h.